package org.drools;

/*
 * Copyright 2005 JBoss Inc
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Persistent handle to an asserted fact.
 *
 * @see WorkingMemory#assertObject
 *
 * @author <a href="mailto:bob@werken.com">bob mcwhirter </a>
 */

import java.io.Serializable;

public interface FactHandle
    extends
    Serializable {

    /**
     * Convert this handle to an external representation.
     * 
     * @return The external string form.
     */
    String toExternalForm();
}
